"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CertificatePersistedHandler = void 0;
const issuer_api_1 = require("@energyweb/issuer-api");
const cqrs_1 = require("@nestjs/cqrs");
const validate_batch_1 = require("../batch/validate.batch");
const persistance_service_1 = require("../persistance.service");
let CertificatePersistedHandler = class CertificatePersistedHandler {
    constructor(persistanceService, eventBus) {
        this.persistanceService = persistanceService;
        this.eventBus = eventBus;
    }
    async handle(event) {
        const certificateId = event.certificateId;
        const isTemporarilyPersisted = await this.persistanceService.isTemporarilyPersisted(certificateId);
        if (isTemporarilyPersisted) {
            await this.persistanceService.markEtrPersisted(certificateId);
            this.eventBus.publish(new validate_batch_1.AwaitingValidationEvent());
        }
        else {
            await this.persistanceService.markTemporarilyPersisted(certificateId);
        }
    }
};
CertificatePersistedHandler = __decorate([
    cqrs_1.EventsHandler(issuer_api_1.CertificatePersistedEvent),
    __metadata("design:paramtypes", [persistance_service_1.PersistanceService, cqrs_1.EventBus])
], CertificatePersistedHandler);
exports.CertificatePersistedHandler = CertificatePersistedHandler;
//# sourceMappingURL=CertificatePersisted.handler.js.map